Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
- AccessorSynthesis
- CleanUp
- Constructors
- Delambdafy
- Erasure
- ExplicitOuter
- ExtensionMethods
- Fields
- Flatten
- InfoTransform
- LambdaLift
- Mixin
- OverridingPairs
- PostErasure
- SampleTransform
- SpecializeTypes
- Statics
- TailCalls
- Transform
- TypeAdaptingTransformer
- TypingTransformers
- UnCurry

t

scala.tools.nsc.transform

# Transform

###

#### trait Transform extends SubComponent

A base class for transforms.

A transform contains a compiler phase which applies a tree transformer.

Source
  Transform.scala
Version

  1.0

Linear Supertypes
SubComponent, AnyRef, Any
Known Subclasses
cleanup, constructors, delambdafy, erasure, explicitOuter, extensionMethods, fields, flatten, lambdaLift, mixer, patmat, postErasure, refChecks, specializeTypes, superAccessors, tailCalls, uncurry, AccessorSynthesis, CleanUp, Constructors, Delambdafy, Erasure, ExplicitOuter, ExtensionMethods, Fields, Flatten, InfoTransform, LambdaLift, Mixin, PostErasure, SampleTransform, SpecializeTypes, Statics, TailCalls, UnCurry, PatternMatching, RefChecks, SuperAccessors
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Transform
2. SubComponent
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  abstract class StdPhase extends GlobalPhase

   A standard phase template

   A standard phase template

   Definition Classes
     SubComponent
2.  class Phase extends StdPhase

   The phase defined by this transform

### Abstract Value Members

1.  abstract val global: Global

   The global environment; overridden by instantiation in Global.

   The global environment; overridden by instantiation in Global.

   Definition Classes
     SubComponent
2.  abstract def newTransformer(unit: Global.CompilationUnit): Global.Transformer

   The transformer factory

   The transformer factory

   Attributes
     protected
3.  abstract val phaseName: String

   The name of the phase

   The name of the phase

   Definition Classes
     SubComponent
4.  abstract val runsAfter: List[String]

   Names of phases that must run before this phase.

   Names of phases that must run before this phase.

   Definition Classes
     SubComponent
5.  abstract val runsRightAfter: Option[String]

   Name of the phase that this phase must follow immediately.

   Name of the phase that this phase must follow immediately.

   Definition Classes
     SubComponent

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Transform toany2stringadd[Transform] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Transform, B)
   Implicit
     This member is added by an implicit conversion from Transform toArrowAssoc[Transform] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def afterOwnPhase[T](op: => T): T
   Definition Classes
     SubComponent
   Annotations
     @inline()
7.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
8.  final def beforeOwnPhase[T](op: => T): T
   Definition Classes
     SubComponent
   Annotations
     @inline()
9.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
10.  def enabled: Boolean

    Is this component enabled? Default is true.

    Is this component enabled? Default is true.

    Definition Classes
      SubComponent
11.  def ensuring(cond: (Transform) => Boolean, msg: => Any): Transform
    Implicit
      This member is added by an implicit conversion from Transform toEnsuring[Transform] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: (Transform) => Boolean): Transform
    Implicit
      This member is added by an implicit conversion from Transform toEnsuring[Transform] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: Boolean, msg: => Any): Transform
    Implicit
      This member is added by an implicit conversion from Transform toEnsuring[Transform] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: Boolean): Transform
    Implicit
      This member is added by an implicit conversion from Transform toEnsuring[Transform] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
16.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
17.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
18.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Transform toStringFormat[Transform] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
19.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
20.  def hashCode(): Int

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    Definition Classes
      SubComponent → AnyRef → Any
21.  val initial: Boolean

    True if this phase runs before all other phases.

    True if this phase runs before all other phases. Usually, `parser`.

    Definition Classes
      SubComponent
22.  val internal: Boolean

    True if this phase is not provided by a plug-in.

    True if this phase is not provided by a plug-in.

    Definition Classes
      SubComponent
23.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
24.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
25.  def newPhase(prev: nsc.Phase): StdPhase

    Create a new phase which applies transformer

    Create a new phase which applies transformer

    Definition Classes
      Transform → SubComponent
26.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
27.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
28.  def ownPhase: nsc.Phase

    The phase corresponding to this subcomponent in the current compiler run

    The phase corresponding to this subcomponent in the current compiler run

    Definition Classes
      SubComponent
29.  def phaseNewFlags: Long

    New flags defined by the phase which are not valid before

    New flags defined by the phase which are not valid before

    Definition Classes
      SubComponent
30.  def phaseNextFlags: Long

    New flags defined by the phase which are not valid until immediately after it

    New flags defined by the phase which are not valid until immediately after it

    Definition Classes
      SubComponent
31.  val requires: List[String]

    Names of phases required by this component.

    Names of phases required by this component. Default is `Nil`.

    Definition Classes
      SubComponent
32.  val runsBefore: List[String]

    Names of phases that must run after this phase.

    Names of phases that must run after this phase. Default is `Nil`.

    Definition Classes
      SubComponent
33.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
34.  val terminal: Boolean

    True if this phase runs after all other phases.

    True if this phase runs after all other phases. Usually, `terminal`.

    Definition Classes
      SubComponent
35.  def toString(): String
    Definition Classes
      AnyRef → Any
36.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
37.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
38.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (Transform, B)
   Implicit
     This member is added by an implicit conversion from Transform toArrowAssoc[Transform] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from SubComponent

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromTransform to any2stringadd[Transform]

### Inherited by implicit conversion StringFormat fromTransform to StringFormat[Transform]

### Inherited by implicit conversion Ensuring fromTransform to Ensuring[Transform]

### Inherited by implicit conversion ArrowAssoc fromTransform to ArrowAssoc[Transform]

### Ungrouped